/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Standard library for Gont, Bitvector module implementation.
 */

open Bitvector;

void or(t dst, t src)
{
	if (length(dst) < length(src))
		resize(dst, length(src), false);
		
	for (int i = 0; i < length(src); i++)
		if (get(src, i))
			set(dst, i, true);
}

void and(t dst, t src)
{
	if (length(dst) < length(src))
		resize(dst, length(src), false);
		
	for (int i = 0; i < length(src); i++)
		if (!get(src, i))
			set(dst, i, false);
}
