/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Standard library for Gont, Inthash module implementation.
 *
 * Hash from int to whatever.
 *
 * TODO: reimplement this in faster manner.
 */

struct <'a, 'b>t {
	<'b>Hashtbl::t h;
	'a dummy;	// FIXME: OGCB
};

<'a, 'b>t create(int size_hint)
{
	return ({h = Hashtbl::create(size_hint),
		 dummy = Hacks::cast(0)});
}

<'a, 'b>t copy(<'a, 'b>t h)
{
	return ({h = Hashtbl::copy(h.h),
		 dummy = Hacks::cast(0)});
}

'b find(<'a, 'b>t h, 'a v)
{
	return Hashtbl::find(h.h, itoa(Hacks::ptr_of(v)));
}

<'b>List::t find_all(<'a, 'b>t h, 'a v)
{
	return Hashtbl::find_all(h.h, itoa(Hacks::ptr_of(v)));
}

bool mem(<'a, 'b>t h, 'a v)
{
	return Hashtbl::mem(h.h, itoa(Hacks::ptr_of(v)));
}

void add(<'a, 'b>t h, 'a k, 'b v)
{
	Hashtbl::add(h.h, itoa(Hacks::ptr_of(k)), v);
}

void iter(<'a, 'b>t h, *(void ('a, 'b)) f)
{
	void ff(string k, 'b v)
	{
		f(Hacks::cast(atoi(k)), v);
	}

	Hashtbl::iter(h.h, ff);
}

void remove(<'a, 'b>t h, 'a k)
{
	Hashtbl::remove(h.h, itoa(Hacks::ptr_of(k)));
}

void remove_all(<'a, 'b>t h, 'a k)
{
	Hashtbl::remove_all(h.h, itoa(Hacks::ptr_of(k)));
}

int length(<'a, 'b>t h)
{
	return Hashtbl::length(h.h);
}
